include "common.iol"
include "console.iol"

execution{ sequential }

// "http://localhost:8080/sum?x=5&y=6"

inputPort In2 {
  Location: "socket://localhost:8080"
  Protocol: http { .format = "json" }
  Interfaces: CalculatorInterface
}

inputPort In {
  Location: "socket://localhost:8000"
  Protocol: sodep
  Interfaces: CalculatorInterface
}

define checkType {
      if( a.x + a.y instanceof string ) {
        println@Console( "string!!!" )();
        a.x = int( a.x );
        a.y = int( a.y )
      }
}

main
{
  [sum( a )( b ) {
      checkType;
      println@Console( a.x + " + " + a.y )();
      b = a.x + a.y
    }]
  [prod( a )( b ) {
    checkType;
      println@Console( a.x + " x " + a.y )();
      b = a.x * a.y
    }]

}
